=== tests/dragonfly/requirements.txt ===
async-timeout==4.0.2
attrs==22.1.0
Deprecated==1.2.13
iniconfig==1.1.1
packaging==21.3
pluggy==1.0.0
py==1.11.0
pyparsing==3.0.9
pytest==7.1.2
redis==5.0.0
tomli==2.0.2
wrapt==1.14.1
pytest-asyncio==0.20.1
pytest-repeat==0.9.3
pymemcache==4.0.0
prometheus_client==0.17.0
aiohttp==3.10.2
numpy
pytest-json-report==1.5.0
psutil==5.9.5
boto3==1.28.55
redis-om==0.3.3
pytest-emoji==0.2.0
pytest-icdiff==0.8
pytest-timeout==2.2.0
asyncio==3.4.3
